<script setup lang="ts">
import exampleSteps from "./example_steps";
import exampleInput from "./example_input";

const queryPipeline = inject(queryPipelineKey);
if (queryPipeline === undefined) {
  throw new Error("Cannot inject query pipeline");
}

const { selectedSteps } = queryPipeline;
const input = ref("");

const loadExample = () => {
  selectedSteps.value = [...exampleSteps];
  input.value = exampleInput;
};

const clear = () => {
  selectedSteps.value = [];
  input.value = "";
};

const { submit } = useQueryPipelineService();
const { data, status, error, execute } = await useAsyncData(
  async () => {
    if (!input.value || selectedSteps.value.length === 0) {
      return "";
    }
    return await submit(selectedSteps.value, input.value);
  },
  { immediate: false },
);

const { xs } = useDisplay();
</script>

<template>
  <v-row>
    <v-col cols="12" md="3" sm="4">
      <h2 class="text-h4">1. Paste IDs</h2>
      <v-textarea
        v-model="input"
        variant="outlined"
        hide-details
        class="mb-2"
      />
      <v-btn size="small" variant="outlined" @click="loadExample"
        >Load example data</v-btn
      >
    </v-col>
    <v-divider v-if="!xs" vertical></v-divider>
    <v-col>
      <QueryPipelineStepList />
    </v-col>
  </v-row>
  <v-row class="mb-4">
    <v-col class="text-right">
      <v-btn variant="outlined" class="mr-2" @click="clear">Reset</v-btn>
      <v-btn
        color="primary"
        :disabled="selectedSteps.length === 0 || !input"
        @click="execute"
        >Submit query</v-btn
      >
    </v-col>
  </v-row>
  <v-divider></v-divider>

  <v-row>
    <v-col>
      <h2 class="text-h4 mt-4">Results</h2>
    </v-col>
    <v-col cols="12">
      <AsyncView
        :loading="status === 'pending'"
        :error="error"
        error-message="Execution failed"
      >
        <QueryPipelineResult v-if="data" :result="data || ''" />
        <NoDataText v-else />
      </AsyncView>
    </v-col>
  </v-row>
</template>
